// ExtTabModel.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "ExtTabModel.h"
#include "MyBackShape.h"

/////////////////////////////////////////////////////////////////////////////
// CExtTabModel construction/destruction

IMPLEMENT_SERIAL(CExtTabModel, CFOTabPageModel, 0)

CExtTabModel::CExtTabModel()
{
	//FOTO:Add you code here.
	this->SetPageHeightWithPrintPages(1);
	SetPageWidthWithPrintPages(1);
	SetLockWithPages(TRUE);
	m_bFormMode = FALSE;
	m_strImageFile = _T("");
	m_bCenterImage = TRUE;
	//	SetUIUnit(FUNIT_CM);
	SetGridLineType(GRID_VISIO);
	SetBackDrawComp(new CMyBackShape);
}

CExtTabModel::CExtTabModel(const CExtTabModel& source)
{
	m_strImageFile = _T("");
	m_bCenterImage = TRUE;
	*this			= source;
}

CExtTabModel::~CExtTabModel()
{
	//FOTO:Add you code here.

}

CFODataModel* CExtTabModel::Copy() const
{
	return (new CExtTabModel(*this));
}

void CExtTabModel::DoInitData()
{
	CFOTabPageModel::DoInitData();

	//FOTO:Add you code here.
}

CFOToolBoxItem *CExtTabModel::DoGetSelectToolboxItem()
{
	 
	
	return NULL;
}

void CExtTabModel::NotifyObserver(LPARAM lHint, CObject*pHint)
{
	CFOTabPageModel::NotifyObserver(lHint,pHint);

	//FOTO:Add you code here.

}

void CExtTabModel::UpdateTitle()
{
	CFOTabPageModel::UpdateTitle();

//	if(m_pOwner == NULL)
//	{
//		return;
//	}
//
//	if(m_pOwner->GetSafeHwnd() != NULL)
//	{
//		if(m_pOwner ->IsKindOf(RUNTIME_CLASS(CFODrawView)))
//		{
//			CFODrawView *pView = (CFODrawView *) m_pOwner;
//			CDocument *m_pDocument = (CDocument *)pView->GetDocument();
//			if(m_pDocument != NULL)
//			{
//				if (m_strTitleOrg.IsEmpty() && !m_pDocument->GetTitle().IsEmpty())
//					m_strTitleOrg = m_pDocument->GetTitle();
//				
//				if (!m_strTitleOrg.IsEmpty())
//				{
//					TCHAR szStr[256+_MAX_PATH];
//					_tcscpy(szStr, m_strTitleOrg);
//					if (IsDirty())
//					{
//						if(m_strTitleOrg.Find(_T("*"))<0)
//						{
//							lstrcat(szStr, _T(" *"));
//						}
//					}
//					if (m_pDocument->GetTitle() != szStr)
//					{
//						m_pDocument->SetTitle(szStr);
//						m_pDocument->UpdateFrameCounts();
//					}
//				}
//			}
//		}
//	}
}

void CExtTabModel::DoActionChange(const CFOBaseAction* pAction)
{
	CFOTabPageModel::DoActionChange(pAction);
	
	// FODO:Add your own specify code here.

}

CString CExtTabModel::CreateBaseName(UINT nType)
{
	CString strReturn;
	strReturn = "nLine";
	 
	{
		return CFOTabPageModel::CreateBaseName(nType);
	}
}

CString CExtTabModel::CreateBaseCaption(UINT nType)
{
	CString strReturn;
	strReturn = "Line";
	 
	{
		return CFOTabPageModel::CreateBaseCaption(nType);
	}

}

CString CExtTabModel::GetUniqueName(UINT nType)
{
	return CFOTabPageModel::GetUniqueName(nType);
}

CString CExtTabModel::GetUniqueCaption(UINT nType)
{

	return CFOTabPageModel::GetUniqueCaption(nType);
}

CFODrawShape *CExtTabModel::DoCreateShapeByType(UINT m_drawshape,
														CRect &rcCreate,
														CString strFileName,
														CFOToolBoxItem *pCurItem)
{
	CFODrawShape *pReturn = NULL;
	CString strCaption;
	CString strName;
	strCaption = "";
	strName = "";
	CPoint ptTrack = rcCreate.TopLeft();
	if(m_drawshape != FO_COMP_NONE)
	{
		CRect rc(rcCreate);
		rc.NormalizeRect();
		 
		{
			pReturn = CFOTabPageModel::DoCreateShapeByType(m_drawshape,rcCreate,strFileName);
		}
	}
	return pReturn;
}

void CExtTabModel::DoInitCreateShape(CFODrawShape *pShape)
{
	CFODataModel::DoInitCreateShape(pShape);
	if (pShape != NULL)
	{
		/*if(HAS_BASE(pShape, CFOCompositeShape))
		{
		CFOCompositeShape *pComp = static_cast<CFOCompositeShape *>(pShape);
		if(!HAS_BASE(pShape, CFOPSubGraphShape))
		{
		CString strState = pComp->GetStateString();
		if(!strState.IsEmpty())
		{
		pComp->SetAllowHitChild(FALSE);
		}
		else
		{
		if(!IsHitAllowShape(pComp))
		{
		pComp->SetAllowHitChild(FALSE);
		}
		}

		if(pComp->GetCompCount() == 1)
		{
		CFODrawShape *pCur = (CFODrawShape *)pComp->GetShapeAt(0);
		if(pCur != NULL)
		{
		int nType = pCur->GetType();
		if(IsNeedType(pCur, nType))
		{
		if(!pCur->IsShapeClosed())
		{
		pCur->SetWeight(maCurStyle.GetWeight());
		pCur->SetFaceName(maCurStyle.GetFaceName());
		pCur->SetPointSize(maCurStyle.GetPointSize());
		pCur->SetFontColor(maCurStyle.GetFontColor());
		pCur->SetItalic(maCurStyle.GetItalic());

		if(maCurStyle.m_nLineShapeWidth == 0)
		{
		pCur->SetLineWidth(maCurStyle.GetLineWidth());
		pCur->SetNullPen(TRUE);
		}
		else
		{
		pCur->SetLineWidth(maCurStyle.GetLineWidth());
		pCur->SetNullPen(FALSE);
		}

		if(!m_bNotUseDefault)
		{
		pCur->SetStartArrowType2(maCurStyle.m_nStartArrow);
		pCur->SetEndArrowType2(maCurStyle.m_nEndArrow);
		}

		m_bNotUseDefault = FALSE;

		pCur->SetLineColor(maCurStyle.GetLineColor());

		if(maCurStyle.GetShadow())
		{
		pCur->SetShadow(maCurStyle.GetShadow());
		pCur->SetShadowBrushType(1);
		}
		else
		{
		pCur->SetShadow(maCurStyle.GetShadow());
		pCur->SetShadowBrushType(0);
		}

		pCur->SetShadowColor(maCurStyle.GetShadowColor());
		}
		else
		{
		pCur->SetWeight(maCurStyle.GetWeight());
		pCur->SetFaceName(maCurStyle.GetFaceName());
		pCur->SetPointSize(maCurStyle.GetPointSize());
		pCur->SetFontColor(maCurStyle.GetFontColor());
		pCur->SetItalic(maCurStyle.GetItalic());

		if(IsShapeEffect(pCur))
		{
		if(maCurStyle.GetLineWidth() == 0)
		{
		pCur->SetLineWidth(maCurStyle.GetLineWidth());
		pCur->SetNullPen(TRUE);
		}
		else
		{
		pCur->SetLineWidth(maCurStyle.GetLineWidth());
		pCur->SetNullPen(FALSE);
		if(nType == NEW_HOTSPOT_RECT || nType == NEW_HOTSPOT_ELLIPSE || nType == NEW_HOTSPOT_POLYGON
		)
		{
		pCur->SetBrushType(0);
		}
		else
		{
		pCur->SetBrushType(maCurStyle.GetBrushType());
		}

		pCur->SetBkColor(maCurStyle.GetBkColor());
		pCur->SetPatternColor(maCurStyle.GetPatternColor());

		if(maCurStyle.GetShadow())
		{
		pCur->SetShadow(maCurStyle.GetShadow());
		pCur->SetShadowBrushType(1);
		}
		else
		{
		pCur->SetShadow(maCurStyle.GetShadow());
		pCur->SetShadowBrushType(0);
		}
		}

		pCur->SetLineColor(maCurStyle.GetLineColor());
		pCur->SetShadowColor(maCurStyle.GetShadowColor());

		}

		if(HAS_BASE(pCur, CFOStaticShape))
		{
		pCur->SetNullPen(TRUE);
		pCur->SetBrushType(0);
		}
		}
		}
		}
		}
		}

		}

		int nType = pShape->GetType();
		if(IsNeedType(pShape, nType))
		{
		if(!pShape->IsShapeClosed())
		{
		pShape->SetWeight(maCurStyle.GetWeight());
		pShape->SetFaceName(maCurStyle.GetFaceName());
		pShape->SetPointSize(maCurStyle.GetPointSize());
		pShape->SetFontColor(maCurStyle.GetFontColor());
		pShape->SetItalic(maCurStyle.GetItalic());

		if(maCurStyle.m_nLineShapeWidth == 0)
		{
		pShape->SetLineWidth(maCurStyle.GetLineWidth());
		pShape->SetNullPen(TRUE);
		}
		else
		{
		pShape->SetLineWidth(maCurStyle.GetLineWidth());
		pShape->SetNullPen(FALSE);
		}

		if(!m_bNotUseDefault)
		{
		pShape->SetStartArrowType2(maCurStyle.m_nStartArrow);
		pShape->SetEndArrowType2(maCurStyle.m_nEndArrow);
		}

		m_bNotUseDefault = FALSE;

		pShape->SetLineColor(maCurStyle.GetLineColor());

		if(maCurStyle.GetShadow())
		{
		pShape->SetShadow(maCurStyle.GetShadow());
		pShape->SetShadowBrushType(1);
		}
		else
		{
		pShape->SetShadow(maCurStyle.GetShadow());
		pShape->SetShadowBrushType(0);
		}

		pShape->SetShadowColor(maCurStyle.GetShadowColor());
		}
		else
		{
		pShape->SetWeight(maCurStyle.GetWeight());
		pShape->SetFaceName(maCurStyle.GetFaceName());
		pShape->SetPointSize(maCurStyle.GetPointSize());
		pShape->SetFontColor(maCurStyle.GetFontColor());
		pShape->SetItalic(maCurStyle.GetItalic());

		if(IsShapeEffect(pShape))
		{
		if(maCurStyle.GetLineWidth() == 0)
		{
		pShape->SetLineWidth(maCurStyle.GetLineWidth());
		pShape->SetNullPen(TRUE);
		}
		else
		{
		pShape->SetLineWidth(maCurStyle.GetLineWidth());
		pShape->SetNullPen(FALSE);
		if(nType == NEW_HOTSPOT_RECT || nType == NEW_HOTSPOT_ELLIPSE || nType == NEW_HOTSPOT_POLYGON
		)
		{
		pShape->SetBrushType(0);
		}
		else
		{
		pShape->SetBrushType(maCurStyle.GetBrushType());
		}

		pShape->SetBkColor(maCurStyle.GetBkColor());
		pShape->SetPatternColor(maCurStyle.GetPatternColor());

		if(maCurStyle.GetShadow())
		{
		pShape->SetShadow(maCurStyle.GetShadow());
		pShape->SetShadowBrushType(1);
		}
		else
		{
		pShape->SetShadow(maCurStyle.GetShadow());
		pShape->SetShadowBrushType(0);
		}
		}

		pShape->SetLineColor(maCurStyle.GetLineColor());
		pShape->SetShadowColor(maCurStyle.GetShadowColor());

		}

		if(HAS_BASE(pShape, CFOStaticShape))
		{
		pShape->SetNullPen(TRUE);
		pShape->SetBrushType(0);
		}
		}
		}*/

		//	theApp.UpdateShapeStyle(pShape);

		if (HAS_BASE(pShape, CFOCompositeShape))
		{
			pShape->SetWithLabelShow(FALSE);
		}
	}

	if (HAS_BASE(pShape, CFOCompositeShape))
	{
		CFOCompositeShape *pComp = static_cast<CFOCompositeShape *>(pShape);
		//		COLORREF cr =GetRandomColor(); 
		pShape->SetResizeProtect(TRUE);
		pShape->SetRotateProtect(TRUE);
		pShape->SetShowLabelAtFirst(TRUE);
		pShape->SetWithLabelShow(TRUE);
		pComp->CreateDefaultPort(0.5, 0);
		pComp->CreateDefaultPort(1.0, 0.5);
		pComp->CreateDefaultPort(0.5, 1.0);
		pComp->CreateDefaultPort(0.0, 0.5);
		//	pComp->SetGroupBkColor(cr);
		//	pShape->SetObjectCaption(_T("Title"));
		return;
	}

}

CFOCompositeShape *CExtTabModel::DoCreateCompositeShapeByType(UINT m_drawshape,
																  CRect &rcCreate,
																  CArray<FOPORTVALUE,FOPORTVALUE> *arInitPorts,
																  CString strFileName,
																  UINT nResID,
																  CFOToolBoxItem *pCurItem)
{
	CFOCompositeShape *pReturn = CFOTabPageModel::DoCreateCompositeShapeByType(m_drawshape,
															rcCreate,
															arInitPorts,
															strFileName,
															nResID,
															pCurItem);
	// FODO: Add your own specify code here.

	return pReturn;
}


void CExtTabModel::SetModifiedFlag(BOOL b)
{
	CFOTabPageModel::SetModifiedFlag(b);
	
	//FOTO:Add you code here.

}

BOOL CExtTabModel::IsModified()
{

	//FOTO:Add you code here.

	return CFOTabPageModel::IsModified();
}

void CExtTabModel::Serialize(CArchive& ar)
{
	CFOTabPageModel::Serialize(ar);
	if (ar.IsStoring())
	{
		//FOTO:Add you code here.
		ar << m_strImageFile;
		ar << m_bCenterImage;

		maCurStyle.Serialize(ar);
	}
	else
	{
		//FOTO:Add you code here.

		ar >> m_strImageFile;
		ar >> m_bCenterImage;
		maCurStyle.Serialize(ar);
		m_strImageFile.TrimLeft();
		m_strImageFile.TrimRight();
		CMyBackShape *pBack = (CMyBackShape *)GetBackDrawComp();
		pBack->SetNewImage(m_strImageFile);
		pBack->m_bCenterImage = m_bCenterImage;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPrintBaseJob serialization
CFile* CExtTabModel::GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,
							 CFileException* pError)
{
	CMirrorFile* pFile = new CMirrorFile;
	ASSERT(pFile != NULL);
	if (!pFile->Open(lpszFileName, nOpenFlags, pError))
	{
		delete pFile;
		pFile = NULL;
	}
	return pFile;
}

void CExtTabModel::ReleaseFile(CFile* pFile, BOOL bAbort)
{
	ASSERT_KINDOF(CFile, pFile);
	if (bAbort)
		pFile->Abort(); // will not throw an exception
	else
		pFile->Close();
	delete pFile;
}

BOOL CExtTabModel::OpenDocument(LPCTSTR lpszPathName)
{
	CFileException fe;
	CFile* pFile = GetFile(lpszPathName,
		CFile::modeRead|CFile::shareDenyWrite, &fe);
	if (pFile == NULL)
	{
		return FALSE;
	}
	strCurOpenFormFile = CString(lpszPathName);
	CArchive loadArchive(pFile, CArchive::load | CArchive::bNoFlushOnDelete);
	loadArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		if (pFile->GetLength() != 0)
			Serialize(loadArchive);     // load me
		loadArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
	return TRUE;
}

BOOL CExtTabModel::SaveDocument(LPCTSTR lpszPathName)
{
	CFileException fe;
	CFile* pFile = NULL;
	pFile = GetFile(lpszPathName, CFile::modeCreate |
		CFile::modeReadWrite | CFile::shareExclusive, &fe);
	
	if (pFile == NULL)
	{
		
		return FALSE;
	}
	strCurOpenFormFile = CString(lpszPathName);
	CArchive saveArchive(pFile, CArchive::store | CArchive::bNoFlushOnDelete);
	saveArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		Serialize(saveArchive);     // save me
		saveArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
	return TRUE;        // success
}

void CExtTabModel::OnDrawShape(CDC *pDC,const CRect &rcView)
{
	CFOTabPageModel::OnDrawShape(pDC,rcView);
	//FOTO:Add you code here.

}

void CExtTabModel::OnDrawBack(CDC *pDC,const CRect &rcClip)
{
	CFOTabPageModel::OnDrawBack(pDC,rcClip);
	//FOTO:Add you code here.

}


/////////////////////////////////////////////////////////////////////////////
// CExtTabModel diagnostics

#ifdef _DEBUG
void CExtTabModel::AssertValid() const
{
	CFOTabPageModel::AssertValid();
}

void CExtTabModel::Dump(CDumpContext& dc) const
{
	CFOTabPageModel::Dump(dc);
}
#endif //_DEBUG

CFODrawShape* CExtTabModel::FindShapeWithName(CString str)
{
	CFODrawShape* pObj = NULL;
	int xy = 0;
	for(xy = 0; xy < m_ShapeList.GetCount(); xy ++)
	{
		pObj = (CFODrawShape*)(m_ShapeList.GetObject(xy));
		if(pObj->GetObjectName() == str)
		{
			return pObj;
		}
	}
	
	return NULL;
	
}

void CExtTabModel::OutputHtml1(const CString &strFileName, const CString &strName, int nIndex)
{
	CStdioFile outFile;
	CFileException ex;
	CString strText;
	if (1)
	{
		if (!outFile.Open(strFileName, CFile::modeWrite | CFile::modeCreate | CFile::typeText, &ex))
		{
			ex.ReportError();
			return;
		}

		strText += "<HTML>\n";
		strText += "<HEAD>\n";
		strText += "	<META HTTP-EQUIV=\"CONTENT-TYPE\" CONTENT=\"TEXT/HTML\">\n";
		CString strTemp;

		strText += "	<TITLE>" + strName + "</TITLE>\n";
		strText += "	<script>\n";
		strText += "		window.onload = function(){\n";
		strText += "			var tmpElemHeader = document.createElement('div');\n";

		strTemp.Format(_T("%s_Page-%u_hdr.html"), strName, nIndex);
		strText += "			tmpElemHeader.innerHTML = '<iframe name=\"hdr\" id=\"hdrID\" src=\"" + strTemp + "\" style=\"width: 100%; height: 100;\" frameborder=\"no;\" scrolling = \"no\">';\n";
		strText += "			var iframe = tmpElemHeader.firstChild;\n";
		strText += "			document.body.appendChild(iframe);\n";
		strText += "		\n";
		strText += "			var hash = window.location.hash;\n";
		strText += "			//console.log(hash);\n";

		strTemp.Format(_T("%s_Page-%u-pic.html"), strName, nIndex);
		strText += "			var src = \"" + strTemp + "\" + hash;\n";
		strText += "			\n";
		strText += "			var pictHeight = document.body.clientHeight - 120;\n";
		strText += "			var pictWidth = document.body.clientWidth-3;\n";
		strText += "			var tmpElemPict = document.createElement('div');\n";
		strText += "			tmpElemPict.innerHTML = '<div id=\"divID\" style=\"position:relative;width:'+pictWidth+';height:'+pictHeight+';\"><iframe name=\"pict\" id=\"pictID\" src=\"'+ src +'\" style=\"width: 100%; height:100%; \"position:absolute;z-index:-1;\" frameborder=\"no;\" scrolling = \"auto\" ></div>';\n";
		strText += "			iframe = tmpElemPict.firstChild;\n";
		strText += "			document.body.appendChild(iframe);\n";
		strText += "		}\n";
		strText += "		window.onresize = function()\n";
		strText += "		{\n";
		strText += "			var dv	 = document.getElementById(\"divID\");\n";
		strText += "			if(dv != null)\n";
		strText += "			{\n";
		strText += "				dv.style.width = document.body.clientWidth - 3;\n";
		strText += "				var hdr = document.getElementById(\"hdrID\");\n";
		strText += "				if(hdr != null)\n";
		strText += "				{\n";
		strText += "					dv.style.height  = document.body.clientHeight - 110;\n";
		strText += "					console.log(document.body.clientHeight);\n";
		strText += "				}\n";
		strText += "			}\n";
		strText += "		}\n";
		strText += "	</script>\n";
		strText += "</HEAD>\n";
		strText += "<BODY STYLE=\"MARGIN: 0\"></BODY>\n";
		strText += "</HTML>\n";


		outFile.WriteString(strText);

		outFile.Close();
	}

}

void CExtTabModel::OutputHtml2(const CString &strFileName, const CString &strName, int nIndex)
{
	int nTotal = this->GetManager()->m_arTabs.GetSize();

	CStdioFile outFile;
	CFileException ex;
	CString strText;
	if (1)
	{
		if (!outFile.Open(strFileName, CFile::modeWrite | CFile::modeCreate | CFile::typeText, &ex))
		{
			ex.ReportError();
			return;
		}

		CString strTemp;
		strText += "<HTML>\n";
		strText += "<HEAD>\n";
		strText += "	<META HTTP-EQUIV=\"CONTENT-TYPE\" CONTENT=\"TEXT/HTML; CHARSET=WINDOWS-1251\">\n";
		strText += "	<TITLE>Main Diagram</TITLE>\n";
		strText += "	<STYLE TYPE=\"TEXT/CSS\">\n";
		strText += "		A:LINK{COLOR: #FFFFFF;}\n";
		strText += "		A:VISITED{COLOR: #FFFFFF;}\n";
		strText += "		A:HOVER{COLOR: #33FF00;}\n";
		strText += "		.PREV{POSITION: relative; LEFT:79;}\n";
		strText += "		.NEXT{POSITION: relative; LEFT:96;}\n";
		strText += "	</STYLE>\n";
		strText += "<!--[if lt IE 7]>\n";
		strText += "<![if gte IE 5.5]>\n";
		strText += "<script type=\"text/javascript\" src=\"fixpng.js\">\n";
		strText += "</script>\n";
		strText += "<style type=\"text/css\">\n";
		strText += ".iePNG, IMG { filter:expression(fixPNG(this)); }\n";
		strText += ".iePNG A { position: relative; }\n";
		strText += "</style>\n";
		strText += "<![endif]>\n";
		strText += "<![endif]-->\n";
		strText += "</HEAD>\n";
		strText += "<BODY STYLE=\"MARGIN: 0; PADDING: 0; BACKGROUND-COLOR: #FFFFFF;\">\n";
		strText += "	<TABLE STYLE=\"POSITION: ABSOLUTE; LEFT: 0; TOP: 0; WIDTH: 100%; HEIGHT:100\" BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
		strText += "		<TD ALIGN=LEFT WIDTH=150>\n";
		strText += "			<IMG STYLE=\"POSITION: ABSOLUTE; LEFT: 0; TOP: 0;\" SRC=\"CDLogo_left.png\">\n";
		strText += "		</TD>\n";
		strText += "		<TD ALIGN=LEFT>\n";
		strText += "			<IMG STYLE=\"POSITION: relative; LEFT: 0; TOP: 0; WIDTH: 100%;  height:100; filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='blank.gif', sizingMethod='scale');\" SRC=\"CDLogo_center.png\">\n";
		strText += "		</TD>\n";
		strText += "		<TD ALIGN=LEFT WIDTH=294>\n";
		strText += "			<IMG STYLE=\"POSITION: relative; LEFT: 0; TOP: 0;\" SRC=\"CDLogo_right.png\">\n";
		strText += "		</TD>\n";
		strText += "	</TABLE>\n";
		strText += "	<TABLE STYLE=\"POSITION: ABSOLUTE; LEFT: 0; TOP: 0; WIDTH: 100%; HEIGHT:100\"  BORDER=0>\n";
		strText += "			<TD VALIGN=MIDDLE >\n";


		strText += "				<SPAN STYLE=\"COLOR: WHITE; FONT-SIZE: 24pt; PADDING-LEFT:150\">" + strName + "</SPAN>\n";
		strText += "			</TD>\n";
		strText += "			<TD VALIGN=MIDDLE  WIDTH=294>\n";

		strTemp.Format(_T("%s_Page-1.html"), strName);
		strText += "				<A TITLE=\"Home\" HREF=\"" + strTemp + "\" TARGET=\"_top\"><IMG SRC=\"Home.png\" ALT=\"Prev\" STYLE=\"POSITION: relative;  LEFT: 62;\" BORDER=0></A>\n";

		if (nIndex <= 1)
		{
			strText += "				<IMG CLASS=\"PREV\" SRC=\"Previous_gray.png\" BORDER=0>\n";
		}
		else
		{
			strTemp.Format(_T("%s_Page-%u.html"), strName, nIndex - 1);
			strText += "				<A TITLE=\"Prev\" HREF=\"" + strTemp + "\" TARGET=\"_top\" NAME=\"Prev\"><IMG CLASS=\"PREV\" SRC=\"Previous.png\" BORDER=0></A>\n";

		}

		if (nIndex == nTotal)
		{
			strText += "				<IMG CLASS=\"NEXT\" SRC=\"Next_gray.png\" BORDER=0>\n";

		}
		else
		{
			strTemp.Format(_T("%s_Page-%u.html"), strName, nIndex + 1);
			strText += "				<A TITLE=\"Next\" HREF=\"" + strTemp + "\" TARGET=\"_top\" NAME=\"Next\"><IMG CLASS=\"NEXT\" SRC=\"Next.png\" BORDER=0></A>\n";

		}
		strText += "			</TD>\n";
		strText += "	</TABLE>\n";
		strText += "</BODY>\n";
		strText += "</HTML>\n";

		outFile.WriteString(strText);

		outFile.Close();
	}

}


void CExtTabModel::DoOutput(const CString &strPath, const CString &strTitle, int nIndex)
{
	CString strTemp;
	strTemp.Format(_T("%u"), nIndex);
	CString strFile = strPath + strTitle + "_Page-" + strTemp + ".png";
	SavePng(strFile);

	strFile = strPath + strTitle + "_Page-" + strTemp + ".html";
	OutputHtml1(strFile, strTitle, nIndex);

	strFile = strPath + strTitle + "_Page-" + strTemp + "_hdr.html";
	OutputHtml2(strFile, strTitle, nIndex);

	strFile = strPath + strTitle + "_Page-" + strTemp + "-pic.html";
	OutputHtml3(strFile, strTitle, nIndex);
}

void CExtTabModel::OutputHtml3(const CString &strFileName, const CString &strName, int nIndex)
{
	CStdioFile outFile;
	CFileException ex;
	CString strText;
	if (1)
	{
		if (!outFile.Open(strFileName, CFile::modeWrite | CFile::modeCreate | CFile::typeText, &ex))
		{
			ex.ReportError();
			return;
		}

		CString strTemp;
		strText += "<HTML>\n";
		strText += "<HEAD>\n";
		strText += "	<META HTTP-EQUIV=\"CONTENT-TYPE\" CONTENT=\"TEXT/HTML;\">\n";


		strText += "	<TITLE>" + strName + "</TITLE>\n";
		strText += "	<script src=\"https://ajax.googleapis.com/ajax/libs/jquery/2.1.4/jquery.min.js\"></script>\n";
		strText += "</HEAD>\n";
		strText += "<BODY STYLE=\"MARGIN: 0\">\n";
		strText += "	\n";
		strText += "	<TABLE HEIGHT=100% ALIGN=CENTER VALIGN=MIDDLE  CELLSPACING=0 CELLPADDING=0>\n";

		strTemp.Format(_T("%s_Page-%u.png"), strName, nIndex);
		strText += "	<TR><TD><IMG ALIGN=MIDDLE SRC=\"" + strTemp + "\" USEMAP=\"#ConceptDrawMap\" BORDER=0></TD></TR>\n";
		strText += "	</TABLE>\n";
		strText += "<MAP NAME=\"ConceptDrawMap\" id=\"nav\">\n";
		strText += "\n";
		strText += "</MAP>\n";
		strText += "<script>\n";
		strText += "window.onload = function(){\n";
		strText += "	//var t = $(window.location.hash).attr('coordTop');\n";
		strText += "	//var l = $(window.location.hash).attr('coordLeft');\n";
		strText += "	//window.scrollBy(l-10, t-10 );\n";
		strText += "	//console.log($(window.location.hash));\n";
		strText += "	//console.log(t);\n";
		strText += "	//console.log(l);\n";
		strText += "	\n";
		strText += "	setTimeout(scrollToCoords, 10)\n";
		strText += "}\n";
		strText += "function scrollToCoords() {\n";
		strText += "	var t = $(window.location.hash).attr('coordTop');\n";
		strText += "	var l = $(window.location.hash).attr('coordLeft');\n";
		strText += "	window.scrollBy(l-10, t-10 );\n";
		strText += "	//console.log(t);\n";
		strText += "	//console.log(l);\n";
		strText += "}\n";
		strText += "//scroll on same page\n";
		strText += "$(function(){\n";
		strText += "   $(\"#nav\").on(\"click\",\"AREA\", function (event){\n";
		strText += "		\n";
		strText += "		var sHref  = $(this).attr('href');\n";
		strText += "		var n = sHref.lastIndexOf(\"#\");\n";
		strText += "		var sHash = sHref.slice(n+1);\n";
		strText += "		var elem = document.getElementById(sHash);\n";
		strText += "		if(elem != null)\n";
		strText += "		{\n";
		strText += "			event.preventDefault();\n";
		strText += "			sHash = sHref.slice(n);\n";
		strText += "			var t = $(sHash).attr('coordTop');\n";
		strText += "			var l = $(sHash).attr('coordLeft');\n";
		strText += "			window.scrollTo(0, 0 );\n";
		strText += "			window.scrollBy(l-10, t-10 );\n";
		strText += "			//console.log($(sHash));\n";
		strText += "			//console.log(t);\n";
		strText += "			//console.log(l);\n";
		strText += "		}\n";
		strText += "		\n";
		strText += "	});\n";
		strText += "});\n";
		strText += "</script>\n";
		strText += "</BODY>\n";
		strText += "</HTML>\n";

		outFile.WriteString(strText);
		outFile.Close();
	}

}

void CExtTabModel::GetBitmapNew(CBitmap &bmp, int cx, int cy, COLORREF crBack)
{
	CDC dcScreen;
	CDC dcMemNormal;
	CDC dcMemBitmap;
	CBitmap bmpNormal;
	dcScreen.Attach(::GetDC(0));
	dcMemNormal.CreateCompatibleDC(&dcScreen);
	dcMemBitmap.CreateCompatibleDC(&dcScreen);

	CSize size(0, 0);
	size = GetPagePosition().Size();
	//	size += CSize(10,10);

	CSize szComp = CSize(cx, cy);

	HBITMAP hbitmap = CFODrawHelper::CreateVirDevBitmap(&dcScreen, cx, cy);
	bmpNormal.Attach(hbitmap);

	//	bmpNormal.CreateCompatibleBitmap(&dcScreen, cx , cy);
	dcMemNormal.SelectObject(&bmpNormal);

	int nSavedDC2 = dcMemNormal.SaveDC();
	dcMemNormal.SetMapMode(MM_ANISOTROPIC);

	dcMemNormal.SetWindowOrg(0, 0);
	dcMemNormal.SetViewportOrg(0, 0);
	dcMemNormal.SetViewportExt(cx, cy);
	dcMemNormal.SetWindowExt(size.cx, size.cy);

	COLORREF crf = crBack;

	CBrush brush;
	brush.CreateSolidBrush(crf);

	BOOL bGrid = IsGrid();
	BOOL bMargin = HasMargin();
	BOOL bPort = IsPortShow();
	BOOL bBorder = IsBorderShow();

	ShowGrid(FALSE);
	ShowMargin(FALSE);
	ShowPort(FALSE);
	SetBorderShow(FALSE);

	CRect rcPos = CRect(CPoint(0, 0), size);

	m_rcCurClip = rcPos;
	BOOL bSaveL = gfxData.m_bUseLinkRoute;
	gfxData.m_bUseLinkRoute = FALSE;
	gfxData.m_bWithPanningDraw = TRUE;

	DoGenInViewLinks(rcPos);

	OnDrawBack(&dcMemNormal, rcPos);
	OnDrawShapeNormal(&dcMemNormal);
	gfxData.m_bWithPanningDraw = FALSE;

	ShowGrid(bGrid);
	ShowMargin(bMargin);
	ShowPort(bPort);
	SetBorderShow(bBorder);

	dcMemNormal.RestoreDC(nSavedDC2);

	HBITMAP hbitmapx = CFODrawHelper::CreateVirDevBitmap(&dcScreen, cx, cy);
	bmp.Attach(hbitmapx);

	dcMemBitmap.SelectObject(&bmp);

	CRect rcFill(0, 0, cx, cy);
	XDDraw()->GDIFillRect(&dcMemBitmap, &rcFill, &brush);

	brush.DeleteObject();

	dcMemBitmap.StretchBlt(0, 0, cx, cy, &dcMemNormal, 0, 0, cx, cy, SRCCOPY);
	//	XDDraw()->DoDrawBitmap(&dcMemBitmap, &bmpdraw, rcDraw,0,0, szComp.cx, szComp.cy, TRUE, crBack);

	::ReleaseDC(0, dcScreen.Detach());
	bmpNormal.DeleteObject();
	gfxData.m_bUseLinkRoute = bSaveL;
}

void CExtTabModel::SavePng(const CString &strFileName)
{
	FOPSize szCanvas = GetPagePosition().Size();
	CBitmap bmp;
	GetBitmapNew(bmp, szCanvas.cx, szCanvas.cy);

	CDC dcScreen;

	dcScreen.Attach(::GetDC(0));

	CFOImagePNG dib;
	dib.MakeNewBitmap(&dcScreen, &bmp);

	dib.Save(strFileName);

}

void CExtTabModel::ExportToSVG(CString strFileName)
{
	strFileName;
	USES_CONVERSION;

	CStdioFile outFile;
	CFileException ex;
	CString str;

	{
		if (!outFile.Open(strFileName, CFile::modeWrite | CFile::modeCreate | CFile::typeText, &ex))
		{
			ex.ReportError();
			return;
		}
	}

	TRY
	{
		// Write the SVG header
		outFile.WriteString(_T("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n"));
	outFile.WriteString(_T("<!-- Create with UCanCode Software (http://www.ucancode.net/) -->\n"));

	FOPRect rcPos = GetPagePosition();
	CString strO;
	strO.Format(_T("<svg xmlns=\"http://www.w3.org/2000/svg\" version=\"1.1\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" style=\"background-color:#FFFFFF\" id=\"main\" viewBox=\"0 0 %d %d\" width=\"%d\" height=\"%d\">\n"), rcPos.Width(), rcPos.Height(), rcPos.Width(), rcPos.Height());
	outFile.WriteString(strO);

	// the visibility of page is not defined yet
	// if (!pPage->IsVisible()) return;

	if (1) // Export background to svg.
	{
		FOPRect rcBack = GetPagePosition();

		CFORectShape *pRect = new CFORectShape;
		pRect->AddRef();
		pRect->Create(rcBack);
		pRect->SetLineWidth(0);
		pRect->SetNullPen(TRUE);
		pRect->SetBkColor(GetBkColor());
		pRect->SetPatternColor(GetPatternColor());
		pRect->SetBrushType(GetBrushType());
		pRect->ExportToSVG(&outFile);
		pRect->Release();
		//	delete pRect;
		//	pRect = NULL;
	}

	CFODrawShape* pObj = NULL;

	int nCountShape = GetShapes()->GetCount();
	int xy = 0;
	for (xy = 0; xy < nCountShape; xy++)
	{
		pObj = (CFODrawShape*)GetShapes()->GetObject(xy);
		if (pObj != NULL)
		{

			pObj->ExportToSVG(&outFile);

		}
	}

	outFile.WriteString(_T("\n</svg>"));  // end of svg fragment

	strFileName = outFile.GetFilePath();  // save the full path of svg file

	outFile.Close();
	}

		CATCH(CFileException, e)
	{
#ifdef _DEBUG
		afxDump << "File " << strFileName << " creation error.\n";
#endif
	}
	END_CATCH

		TCHAR NameBuff[255];                          // the name of preview html file
	if (GetTempPath(255, NameBuff) == 0) {           // in case no temp directory available
//		_tcscpy(NameBuff, _T("SVG_Preview.html"));  // put it in the current directory
	}
	else {
//		_tcscat(NameBuff, _T("SVG_Preview.html"));
	}


	if (!outFile.Open(_T("SVG_Preview.html"), CFile::modeWrite | CFile::modeCreate | CFile::typeText, &ex))
	{
		ex.ReportError();
		return;
	}

	TRY
	{
		CString s;
	s.Format(_T("<EMBED SRC=\"%s\" WIDTH=\"%d\" HEIGHT=\"%d\">"),
		strFileName, GetCanvasSize().cx, GetCanvasSize().cy);
	outFile.WriteString(s);
	outFile.Close();

	//  ShellExecute(NULL, _T("open"), NameBuff, NULL, NULL, SW_SHOWNORMAL);
	}
		CATCH(CFileException, e)
	{
#ifdef _DEBUG
		afxDump << "File " << NameBuff << " creation error.\n";
#endif
	}
	END_CATCH


		str = outFile.GetFilePath();

	//    AfxGetApp()->GetMainWnd()->SendMessage(SVIZ_WM_SVGEXPORT_UPDATED, (WPARAM)&(str), 0);
}
