#if !defined(AFX_HMIROTATEDUPSETDLG_H__1F1F4468_9285_45CA_83B7_68E9244D13B2__INCLUDED_)
#define AFX_HMIROTATEDUPSETDLG_H__1F1F4468_9285_45CA_83B7_68E9244D13B2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// HMIRotateDupSetDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CHMIRotateDupSetDlg dialog

class CHMIRotateDupSetDlg : public CDialog
{
	// Construction
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// H M I Custom Move Dialog, Constructs a CHMIRotateDupSetDlg object.
	//		Returns A  value.  
	// Parameters:
	//		pParent---pParent, A pointer to the CWnd or NULL if the call failed.
	CHMIRotateDupSetDlg(CWnd* pParent = NULL);   // standard constructor
	
	// Dialog Data
	//{{AFX_DATA(CHMIRotateDupSetDlg)
	enum { IDD = IDD_HMI_ROTATE_DUP };
	CSpinButtonCtrl	m_spinrow;
	int		m_nRows;
	BOOL	m_bTextRotate;
	int		m_nTotalAngle;
	//}}AFX_DATA
	
	// Move Object, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString strMoveObj;
	// m_btnColor, This member specify FOPDropDownColorPickerButton object.  
	FOPDropDownColorPickerButton	m_btnColor;
	
	// Background color object.
	
	// m_btnBackground, This member specify FOPDropDownColorPickerButton object.  
	FOPDropDownColorPickerButton	m_btnBackground;
	
	BOOL m_bEnable;
	// Pattern color.
	
	// F G, This member sets A 32-bit value used as a color value.  
	COLORREF	m_crFG;
	
	// Background color.
	
	// B K, This member sets A 32-bit value used as a color value.  
	COLORREF	m_crBK;

	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHMIRotateDupSetDlg)
protected:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Do Data Exchange, Do a event. 
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		pDX---D X, A pointer to the CDataExchange or NULL if the call failed.
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	
	// Generated message map functions
	//{{AFX_MSG(CHMIRotateDupSetDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	//}}AFX_MSG
	
	//-----------------------------------------------------------------------
	// Summary:
	// E C L A R E_ M E S S A G E_ M A P, None Description.
	//		Returns A  value.
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HMIROTATEDUPSETDLG_H__1F1F4468_9285_45CA_83B7_68E9244D13B2__INCLUDED_)
